<?php
/*
Plugin Name: CleverReach
Plugin URI: http://www.cleverreach.de/
Description: Widget f&uuml;r die Integration eines CleverReach Anmeldeformulars in der Sidebar und Plugin für die Abonnentengewinnung über Kommentare. PHP5 und Soap Extension werden vorausgesetzt.
Version: 1.3.1
Author: CleverReach
Author URI: http://www.cleverreach.de
Update Server: http://www.cleverreach.de/docs/de
Min WP Version: 2.5
*/

$cr_plugin_url = get_option('siteurl').'/wp-content/plugins/cr_plugin/';
$cr_source_name = "WordPress comment";

/* ----------- Administration part ------------ */

function cr_menu() {
  add_options_page('CleverReach Options', 'CleverReach', 8, __FILE__, 'cr_options');
}

function cr_options() {
	global $cr_plugin_url, $cr_prefix, $api;
	$cr_options = get_option("cr_options");

	if(!$cr_options["gbc_text"])
		$cr_options["gbc_text"] = "Newsletter abonnieren";
	
	if($_POST["cr_save"]){
		$cr_options["api_key"] 	=  $_POST['api_key'];
		$cr_options["list_id"] 		=  $_POST['list_id'];
		
		if($_POST['gbc_form_id']){
			$cr_options["gbc"] 			=  $_POST['gbc'];
			$cr_options["gbc_text"]		=  $_POST['gbc_text'];
			$cr_options["gbc_form_id"]	=  $_POST['gbc_form_id'];
		}				
		
		
		update_option("cr_options", $cr_options);
		
	}
	$ca = new cleverreach_api($cr_options["api_key"], $cr_options["list_id"]);
	$cr_login_ok = $ca->login();
	if($cr_login_ok){
		$domain = $ca->get_domain();
		$cr_options["domain"] = $domain;

		update_option("cr_options", $cr_options);
		$list = $ca->get_list();
		if($list){
			$list_id_ok = true;
			$forms = $ca->get_forms();
			if($forms){
				$forms_ok = true;
			}
		}else{
			$cr_login_ok = false;
		}
		
		$api_key_ok = true;
	}
	?>
	
	<div class="wrap"><br />
	<img src="<?php _e($cr_plugin_url) ?>/images/logo.png" />
	<h3>Grundlegende Einstellungen</h3>
	<p>Bitte hinterlegen Sie hier Ihren CleverReach-API-Key. <br />Sie haben noch keinen CleverReach-Account? <a href="http://www.cleverreach.de/frontend/account.php" target="_blank">Melden Sie sich jetzt kostenlos an!</a></p>
	</div>
	<form name="form1" method="post" action="<?php str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
		<table class="form-table">
			<tr valign="top">
				<th scope="row"><label>API Key</label></th>
				<td><input type="text" name="api_key" value="<?php _e($cr_options["api_key"]); ?>" style="width:230px;"><?php if($api_key_ok){ ?> <img src="<?php _e($cr_plugin_url); ?>/images/ok.png" /> <?php } ?></td>
			</tr>
			<tr valign="top">
				<th scope="row"><label>List ID</label></th>
				<td><input type="text" name="list_id" value="<?php _e($cr_options["list_id"]); ?>" style="width:230px;"><?php if($list_id_ok){ ?> <img src="<?php _e($cr_plugin_url); ?>/images/ok.png" /> <?php } ?></td>
			</tr>
			<?php if($cr_login_ok){ ?>
				<tr><td colspan="2"><span style='font-weight:bold; color:#22aa22'>Login erfolgreich</span></td></tr> 
			<?php }else{ ?>
				<tr><td colspan="2"><span style='font-weight:bold; color:#cc2222'>Zugang nicht m&ouml;glich. Bitte &uuml;berpr&uuml;fen Sie Ihre Angaben.</span>
				<br />
				Alternativ k&ouml;nnen Sie den Formularcode manuell im Widget einf&uuml;gen. "Abonnentengewinnung &uuml;ber Kommentare" ist nur mit aktivierter Schnittstelle m&ouml;glich.
				</td></tr> 
			<?php } ?>

		<?php if($cr_login_ok){ ?>
			<tr>
				<td colspan="2" >
				<h3>Abonnentengewinnung &uuml;ber Kommentare</h3>
				Durch die Aktivierung dieser Funktion wird jedem Kommentarformular in Ihrem Blog eine Newsletter-Bestellm&ouml;glichkeit hinzugef&uuml;gt. 
				Der User muss beim Kommentieren nur ein H&auml;kchen setzen und erh&auml;lt eine Best&auml;tigungsmail (Double-Opt-In). 
				Nach der Best&auml;tigung ist er als aktiver Abonnent in einer Empf&auml;ngergruppe des von Ihnen gew&auml;hlten Formulars eingetragen. 
				</td>
			</tr>
			<tr>
				<th scope="row" colspan="2" >Abonenntengewinnung &uuml;ber Kommentare aktivieren: 
				<input type="checkbox" name="gbc" id="gbc" value="checked" <?php _e($cr_options["gbc"]) ?>></th>
			</tr>
			<tr>
				<th scope="row" >Beschreibungstext</th>
				<td><input style="width:400px" type="text" name="gbc_text" value="<?php _e($cr_options["gbc_text"]) ?>"></td>
			</tr>
			<tr>
				<th scope="row" >Formular</th>
				<td>
						<?php 	if($forms){ ?>
						<select name="gbc_form_id" id="gbc_form_id" style="width: 400px;">
						<?php		foreach($forms as $form){ ?>
						<option value="<?php _e($form->id) ?>" <?php if($cr_options["gbc_form_id"]==$form->id) _e("selected"); ?>><?php _e($form->name) ?></option>
						<?php 		}	?>
						</select>
						<?php	}else{ 	?>
						<span style='font-weight:bold; color:#cc2222'>Sie haben noch keine Formulare die Sie verwenden k&ouml;nnten. </span>
						<?php 	} ?> 
					<br /><a href="http://<?php _e($cr_options["domain"]) ?>/admin/forms_list.php" target="_blank">Neues Formular anlegen oder bestehende Formulare bearbeiten</a>	
					
				
				</td>
			</tr>
		<?php } ?>
		</table>
		<input type="submit" value="Speichern">
		<input type="hidden" name="cr_save" value="true">
		<p>*Wird das Anmeldeh&auml;ckchen nicht automatisch in das Kommentarformular eingef&uuml;gt, dann platzieren Sie bitte den folgenden Code innerhalb des "&lt;FORM&gt;" Tags der Datei "comments.php" Ihres aktiven Themes: <i>&lt;?php cr_add_checkbox();?&gt;</i>
		</p>
	</form>

	<?php
	
}

function cr_add_checkbox(){
	$cr_options = get_option("cr_options");
	echo "<input type='checkbox' name='cr_gbc_form_id' id='cr_gbc_form_id' value='".$cr_options["gbc_form_id"]."' style='width:20px' />".$cr_options["gbc_text"];
}

function cr_gbc_subscribe(){
	global $_POST, $user_email, $cr_source_name, $user_login;
	if($_POST["cr_gbc_form_id"]){
		
		$cr_options = get_option("cr_options");
		$form_id = $_POST["cr_gbc_form_id"];
		$ca = new cleverreach_api($cr_options["api_key"], $cr_options["list_id"]);
		
		if(!$name = $_POST["author"])
			$name = $user_login;
		if(! $email = $_POST["email"])
			$email = $user_email;
		
		$cr_receiver = array (
			'email' => $email,
			'registered' => time(),
			'source' => 'Wordpress',
			'attributes' => array(
				array(
					'key' => 'firstname',
					'value' => $name
				)
			)
		);
		
		$result = @$ca->api_client->receiverAdd($cr_options['api_key'], $cr_options['list_id'], $cr_receiver);
		if($result->status == "SUCCESS"){
			$result = @$ca->api_client->formsActivationMail($cr_options['api_key'], $form_id, $email);
		}else{
			unset($cr_receiver["registered"]);
			$result = @$ca->api_client->receiverUpdate($cr_options['api_key'], $cr_options['list_id'], $cr_receiver);
		}
	}
}

/* ------------------ Widget part ---------------- */
function cr_widget_init() 
{
  
  
  if ( !function_exists('register_sidebar_widget') )
    return;
    
    function cr_widget() {
		$form = get_option("cr_form");
    	echo $form;
	}

	function cr_widget_options() {
		$cr_options = get_option("cr_options");
		$ca = new cleverreach_api($cr_options["api_key"], $cr_options["list_id"]);

		if(!$cr_options['widget_init']){
			$cr_options['widget_title']="Newsletter Anmeldung";
			$cr_options['widget_text']="Tragen Sie sich hier in unseren Newsletter ein";
			$cr_options['widget_show_powered']="checked";
			$cr_options['widget_submit_text']="Eintragen";
			$cr_options['widget_init']=$_POST["cr_widget_submit"];
			$cr_options['widget_form_id']='none';
		}
		
		if ($_POST['cr_widget_submit']) {
			$cr_options['widget_title']=strip_tags($_POST["cr_widget_title"]);
			$cr_options['widget_text']=$_POST["cr_widget_text"];
			$cr_options['widget_show_powered']=$_POST["cr_widget_show_powered"];
			$cr_options['widget_form_id']=$_POST["cr_widget_form_id"];
			$cr_options['widget_submit_text']=$_POST["cr_submit_text"];
			$cr_options['widget_formcode']=stripslashes($_POST["cr_widget_formcode"]);
			$cr_options['widget_border']=stripslashes($_POST["cr_widget_border"]);
			$cr_options['widget_init']=$_POST["cr_widget_submit"];
			
			update_option('cr_options', $cr_options);
			$cr_border = "";
			if($cr_options["widget_border"])
				$cr_border=" style='background:#fafafa; border:1px solid #ccc; padding: 3px;'";

			$ca = new cleverreach_api($cr_options["api_key"], $cr_options["list_id"]);
			 
			if($cr_options['widget_show_powered'] == "checked") $badget = true;
			if($cr_options['widget_ssl'] == "checked") $ssl = true;
			
			$echo = $ca->api_client->formsGetCode($cr_options['api_key'], $cr_options['widget_form_id'], $ssl, $badget);
			$form = "";
			if($echo->status == "SUCCESS"){
				$form = "<li id='cleverreach-form' class='widget widget_cr'".$cr_border.">
		    	<h2 class='widgettitle'>".$cr_options["widget_title"]."</h2>".$echo->data."\n</li>\n";
			}
			update_option("cr_form", $form);
			
		}
		$cr_display = "none";
		?>
		<label for="cr_widget_title"><strong><?php _e('&Uuml;berschrift:'); ?></strong></label>
		<input style="width: 100%; margin-bottom:1em;" id="cr_widget_title" name="cr_widget_title" type="text" value="<?php _e(htmlspecialchars(stripslashes($cr_options['widget_title']))); ?>" />

		<label for="cr_widget_border"><strong><?php _e('Rahmen anzeigen?'); ?></strong></label>
		<input type="checkbox" id="cr_widget_border" value="checked" name="cr_widget_border" <?php _e($cr_options['widget_border']) ?> />
		<br/>
		<br/>
		
		<?php if(!$ca->login()){ $cr_display = "block"?>
			<span style="color:#ff2222;">
			<b>Status: </b>Plugin nicht konfiguriert<br>  
			<a href="options-general.php?page=cr_plugin/cleverreach_plugin.php">CleverReach Plugin konfigurieren</a>
			</span>
			<hr />
		<?php }else{ $forms = $ca->get_forms();?>
		
		<label for="cr_widget_form_id"><strong><?php _e('CleverReach Formular:'); ?></strong></label>
		<script>
			function cr_switchl(val){
				var l = document.getElementById('cr_formcode_layer');
				if(val==""){
					l.style.display='block';
				}else{
					l.style.display='none';
				}
			}
		</script>
		
			<?php	if($forms){	?>
			<select name="cr_widget_form_id" id="cr_widget_form_id" style="width: 100%;" onchange="cr_switchl(this.value);">
			<?php		foreach($forms as $form){ ?>
			<option value="<?php _e($form->id) ?>" <?php if($cr_options["widget_form_id"]==$form->id) _e("selected"); ?>><?php _e($form->name) ?></option>
			<?php 		}	?>
			</select>
			<?php	}else{ 	?>
			<p><span style='font-weight:bold; color:#cc2222'>Sie haben noch keine Formulare die Sie verwenden k&ouml;nnten. </span></p>
			<?php 	} ?> 
		<a href="http://<?php _e($cr_options["domain"]) ?>/admin/forms_list.php" target="_blank">Neues Formular anlegen</a>
		<br /><br />
		<?php } ?>

		<label for="cr_widget_show_powered"><strong><?php _e('CleverReach Banner anzeigen?'); ?></strong></label>
		<input type="checkbox" id="cr_widget_show_powered" value="checked" name="cr_widget_show_powered" <?php _e($cr_options['widget_show_powered']) ?> />
		<br /><br />
		<input type="hidden" name="cr_widget_submit" value="true">
	<?php
	}
	if(class_exists("SoapClient")){
		register_sidebar_widget(array('CleverReach', 'CleverReach'), 'cr_widget');
		register_widget_control(array('CleverReach', 'CleverReach'), 'cr_widget_options');
	}
}


/* ------------------ hooks ---------------- */
add_action('widgets_init', 'cr_widget_init');
add_action('admin_menu', 'cr_menu');

$cr_options = get_option("cr_options");
if($cr_options["gbc"] && $cr_options["gbc_form_id"]){
	// This will be overridden if the user manually places the function
	// in the comments form before the comment_form do_action() call
	add_action('comment_form', 'cr_add_checkbox');

	add_action('comment_post', "cr_gbc_subscribe", 50);
	//add_action('comment_post', create_function('$a', 'global $sg_subscribe; sg_subscribe_start(); return $sg_subscribe->add_subscriber($a);'));
}


###############################################################
#	CleverReach API
#	Version: 0.3
#	Author: Aleksej Vasiljkovic / Thorben Meilahn / Cleverreach
#	
#	Date: 05.10.10
#	
#	Redistribution is NOT permitted	
#	
###############################################################


class cleverreach_api {
	var $api_client;
	var $client;
	
	var $api_key		= false;
	var $list_id		= false;

	function cleverreach_api($api_key = false, $list_id = false){
		$cr_options = get_option("cr_options");

		$this->api_client = new SoapClient(null, array("location" => "http://api.cleverreach.com/soap/interface_v5.0.php", "uri" => "urn:".get_option('siteurl')));
		if($api_key){
			$this->api_key = trim($api_key);
		}else{
			$this->api_key = $cr_options["api_key"];
		}
		if($list_id){
			$this->list_id = trim($list_id);
		}else{
			$this->list_id = $cr_options["list_id"];
		}
		
	}
	
	function login($api_key = false){
		if($api_key){
			$this->api_key = $api_key; 
		}
		$this->client = @$this->api_client->clientGetDetails($this->api_key);

		if($this->client->status=="SUCCESS"){
			return true;
		}else
			return false;

	}
	
	function get_domain(){
		return $this->client->data->login_domain;
	}
	
	function get_forms(){
		$ret = @$this->api_client->formsGetList($this->api_key, $this->list_id);
		return $ret->data;
	}
	
	function get_list(){
		$ret = @$this->api_client->groupGetDetails($this->api_key, $this->list_id);
		return $ret->data;
	}
}
?>
